<?php

load_language('plugin.lang', dirname(__FILE__).'/');
include(AUTOUPDATE_PATH.'include/functions.inc.php');
include(PHPWG_ROOT_PATH.'admin/include/pclzip.lib.php');

/*
STEP:
0 = check is needed. If version is latest or check fail, we stay on step 0
1 = new version on same branch AND new branch are available => user may choose upgrade.
2 = upgrade on same branch
3 = upgrade on different branch
*/
$step = isset($_GET['step']) ? $_GET['step'] : 0;

// +-----------------------------------------------------------------------+
// |                                Step 0                                 |
// +-----------------------------------------------------------------------+
if ($step == 0)
{
  if (preg_match('/(\d+\.\d+)\.(\d+)/', PHPWG_VERSION, $matches)
    and @fetchRemote(PHPWG_URL.'/download/all_versions.php', $result)
    and $all_versions = @explode("\n", $result)
    and is_array($all_versions))
  {
    $template->assign('CHECK_VERSION', true);

    $last_version = trim($all_versions[0]);

    if (version_compare(PHPWG_VERSION, $last_version, '<'))
    {
      $new_branch = preg_replace('/(\d+\.\d+)\.\d+/', '$1', $last_version);
      $actual_branch = $matches[1];

      if ($new_branch == $actual_branch)
      {
        $step = 2;
      }
      else
      {
        $step = 3;

        // Check if new version exists in same branch
        foreach ($all_versions as $version)
        {
          $new_branch = preg_replace('/(\d+\.\d+)\.\d+/', '$1', $version);

          if ($new_branch == $actual_branch)
          {
            if (version_compare(PHPWG_VERSION, $version, '<'))
            {
              $step = 1;
            }
            break;
          }
        }
      }
    }
  }
  else
  {
    $template->assign('CHECK_VERSION', false);
  }
}

// +-----------------------------------------------------------------------+
// |                                Step 1                                 |
// +-----------------------------------------------------------------------+
if ($step == 1)
{
  $new_versions = array($last_version, $version);
  $template->assign('new_versions', $new_versions);
}

// +-----------------------------------------------------------------------+
// |                                Step 2                                 |
// +-----------------------------------------------------------------------+
if ($step == 2)
{
  if (isset($_POST['submit']) and isset($_POST['upgrade_to']))
  {
    upgrade_to($_POST['upgrade_to'], $step);
  }

  $template->assign('UPGRADE_TO', isset($_GET['to']) ? $_GET['to'] : $last_version);
}

// +-----------------------------------------------------------------------+
// |                                Step 3                                 |
// +-----------------------------------------------------------------------+
if ($step == 3)
{
  if (isset($_POST['saveTemplate']))
  {
    $path = $conf['local_data_dir'].'/autoupdate';

    if (@mkgetdir($path)
      and ($zip = tempnam($path, 'zip'))
      and ($archive = new pclZip($zip))
      and ($v_list = $archive->add(PHPWG_ROOT_PATH.'template', PCLZIP_OPT_REMOVE_PATH, PHPWG_ROOT_PATH))
      and is_array($v_list)
      and !empty($v_list))
    {
      $http_headers = array(
        'Content-Length: '.@filesize($zip),
        'Content-Type: application/zip',
        'Content-Disposition: attachment; filename="template.zip";',
        'Content-Transfer-Encoding: binary',
        );

      foreach ($http_headers as $header) {
        header($header);
      }

      @readfile($zip);
      autoupdate_deltree($conf['local_data_dir'].'/autoupdate');
      exit();
    }

    array_push($page['errors'], l10n('Unable to send template directory.'));
  }

  if (isset($_POST['dumpDatabase']))
  {
    if (version_compare(PHPWG_VERSION, '2.1', '<'))
    {
      global $cfgBase;
      $conf['db_base'] = $cfgBase;
    }

    include(AUTOUPDATE_PATH.'include/mysqldump.php');

    $path = $conf['local_data_dir'].'/autoupdate';

    if (@mkgetdir($path)
      and ($backupFile = tempnam($path, 'sql'))
      and ($dumper = new MySQLDump($conf['db_base'],$backupFile,false,false)))
    {
      $tablesStructure = array(
        CATEGORIES_TABLE,
        COMMENTS_TABLE,
        CONFIG_TABLE,
        FAVORITES_TABLE,
        GROUP_ACCESS_TABLE,
        GROUPS_TABLE,
        HISTORY_TABLE,
        HISTORY_SUMMARY_TABLE,
        IMAGE_CATEGORY_TABLE,
        IMAGES_TABLE,
        SESSIONS_TABLE,
        SITES_TABLE,
        USER_ACCESS_TABLE,
        USER_GROUP_TABLE,
        USERS_TABLE,
        USER_INFOS_TABLE,
        USER_FEED_TABLE,
        WAITING_TABLE,
        RATE_TABLE,
        USER_CACHE_TABLE,
        USER_CACHE_CATEGORIES_TABLE,
        CADDIE_TABLE,
        UPGRADE_TABLE,
        SEARCH_TABLE,
        USER_MAIL_NOTIFICATION_TABLE,
        TAGS_TABLE,
        IMAGE_TAG_TABLE,
        PLUGINS_TABLE,
        OLD_PERMALINKS_TABLE,
        );

      $tablesData = $tablesStructure;

      if (!isset($_POST['includeHistory']))
      {
        unset($tablesData[6]);
      }

      foreach ($tablesStructure as $table)
      {
        $dumper->getTableStructure($table); 
      }
      foreach ($tablesData as $table)
      {
        $dumper->getTableData($table); 
      }
    }

    if (@filesize($backupFile))
    {
      $http_headers = array(
        'Content-Length: '.@filesize($backupFile),
        'Content-Type: text/x-sql',
        'Content-Disposition: attachment; filename="database.sql";',
        'Content-Transfer-Encoding: binary',
        );

      foreach ($http_headers as $header) {
        header($header);
      }

      @readfile($backupFile);
      autoupdate_deltree($conf['local_data_dir'].'/autoupdate');
      exit();
    }

    array_push($page['errors'], l10n('Unable to dump database.'));
  }

  if (isset($_POST['submit']) and isset($_POST['upgrade_to']))
  {
    upgrade_to($_POST['upgrade_to'], $step);
  }

  $template->assign('UPGRADE_TO', isset($_GET['to']) ? $_GET['to'] : $last_version);
}

// +-----------------------------------------------------------------------+
// |                        Process template                               |
// +-----------------------------------------------------------------------+

$template->assign(array(
  'STEP' => $step,
  'AU_URL' => get_admin_plugin_menu_link(AUTOUPDATE_PATH . '/autoupdate.php'),
  )
);

$template->set_filename('plugin_admin_content', realpath(AUTOUPDATE_PATH.'template/autoupdate.tpl'));
$template->assign_var_from_handle('ADMIN_CONTENT', 'plugin_admin_content');

?>